ServerDeploy (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.taskdefs.optional.j2ee, class: ServerDeploy

# Class ServerDeploy

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.Task
org.apache.tools.ant.taskdefs.optional.j2ee.ServerDeploy

All Implemented Interfaces:
  `Cloneable`

public class ServerDeploy extends Task
Controls hot deployment tools for J2EE servers. This class is used as a framework for the creation of vendor specific hot deployment tools.

See Also:
  - `HotDeploymentTool`
  - `AbstractHotDeploymentTool`
  - `GenericHotDeploymentTool`
  - `WebLogicHotDeploymentTool`

- ## Field Summary

  ### Fields inherited from class Task

  `target, taskName, taskType, wrapper`
  Modifier and Type
  Field
  Description
  `protected Target`
  `target`
  Deprecated.
  since 1.6.x.
  `protected String`
  `taskName`
  Deprecated.
  since 1.6.x.
  `protected String`
  `taskType`
  Deprecated.
  since 1.6.x.
  `protected RuntimeConfigurable`
  `wrapper`
  Deprecated.
  since 1.6.x.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ServerDeploy()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addGeneric(GenericHotDeploymentTool tool)`
  Creates a generic deployment tool.
  `void`
  `addJonas(JonasHotDeploymentTool tool)`
  Creates a JOnAS deployment tool, for deployment to JOnAS servers.
  `void`
  `addWeblogic(WebLogicHotDeploymentTool tool)`
  Creates a WebLogic deployment tool, for deployment to WebLogic servers.
  `void`
  `execute()`
  Execute the task.
  `String`
  `getAction()`
  Returns the action field.
  `File`
  `getSource()`
  Returns the source field (the path/filename of the component to be deployed.
  `void`
  `setAction(String action)`
  The action to be performed, usually "deploy"; required.
  `void`
  `setSource(File source)`
  The filename of the component to be deployed; optional depending upon the tool and the action.

  ### Methods inherited from class Task

  `bindToOwner, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, init, isInvalid, log, log, log, log, maybeConfigure, perform, reconfigure, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`
  Modifier and Type
  Method
  Description
  `final void`
  `bindToOwner(Task owner)`
  Bind a task to another; use this when configuring a newly created task to do work on behalf of another.
  `Target`
  `getOwningTarget()`
  Returns the container target of this task.
  `RuntimeConfigurable`
  `getRuntimeConfigurableWrapper()`
  Returns the wrapper used for runtime configuration.
  `String`
  `getTaskName()`
  Returns the name to use in logging messages.
  `String`
  `getTaskType()`
  Return the type of task.
  `protected RuntimeConfigurable`
  `getWrapper()`
  Return the runtime configurable structure for this task.
  `protected void`
  `handleErrorFlush(String output)`
  Handles an error line by logging it with the WARN priority.
  `protected void`
  `handleErrorOutput(String output)`
  Handles an error output by logging it with the WARN priority.
  `protected void`
  `handleFlush(String output)`
  Handles output by logging it with the INFO priority.
  `protected int`
  `handleInput(byte[] buffer, int offset, int length)`
  Handle an input request by this task.
  `protected void`
  `handleOutput(String output)`
  Handles output by logging it with the INFO priority.
  `void`
  `init()`
  Called by the project to let the task initialize properly.
  `protected final boolean`
  `isInvalid()`
  Has this task been marked invalid?
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `log(String msg, Throwable t, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `log(Throwable t, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `maybeConfigure()`
  Configures this task - if it hasn't been done already.
  `final void`
  `perform()`
  Performs this task if it's still valid, or gets a replacement version and performs that otherwise.
  `void`
  `reconfigure()`
  Force the task to be reconfigured from its RuntimeConfigurable.
  `void`
  `setOwningTarget(Target target)`
  Sets the target container of this task.
  `void`
  `setRuntimeConfigurableWrapper(RuntimeConfigurable wrapper)`
  Sets the wrapper to be used for runtime configuration.
  `void`
  `setTaskName(String name)`
  Sets the name to use in logging messages.
  `void`
  `setTaskType(String type)`
  Sets the name with which the task has been invoked.

  ### Methods inherited from class ProjectComponent

  `clone, getDescription, getLocation, getProject, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ServerDeploy

    public ServerDeploy()

- ## Method Details

  - ### addGeneric

    public void addGeneric(GenericHotDeploymentTool tool)
    Creates a generic deployment tool.

    Ant calls this method on creation to handle embedded "generic" elements in the ServerDeploy task.

    Parameters:
      `tool` - An instance of GenericHotDeployment tool, passed in by Ant.

  - ### addWeblogic

    public void addWeblogic(WebLogicHotDeploymentTool tool)
    Creates a WebLogic deployment tool, for deployment to WebLogic servers.

    Ant calls this method on creation to handle embedded "weblogic" elements in the ServerDeploy task.

    Parameters:
      `tool` - An instance of WebLogicHotDeployment tool, passed in by Ant.

  - ### addJonas

    public void addJonas(JonasHotDeploymentTool tool)
    Creates a JOnAS deployment tool, for deployment to JOnAS servers.

    Ant calls this method on creation to handle embedded "jonas" elements in the ServerDeploy task.

    Parameters:
      `tool` - An instance of JonasHotDeployment tool, passed in by Ant.

  - ### execute

    public void execute() throws BuildException
    Execute the task.

    This method calls the deploy() method on each of the vendor-specific tools in the `vendorTools` collection. This performs the actual process of deployment on each tool.

    Overrides:
      `execute` in class `Task`
    Throws:
      `BuildException` - if the attributes are invalid or incomplete, or a failure occurs in the deployment process.

  - ### getAction

    public String getAction()
    Returns the action field.
    Returns:
      A string representing the "action" attribute.

  - ### setAction

    public void setAction(String action)
    The action to be performed, usually "deploy"; required. Some tools support additional actions, such as "delete", "list", "undeploy", "update"...
    Parameters:
      `action` - A String representing the "action" attribute.

  - ### getSource

    public File getSource()
    Returns the source field (the path/filename of the component to be deployed.
    Returns:
      A File object representing the "source" attribute.

  - ### setSource

    public void setSource(File source)
    The filename of the component to be deployed; optional depending upon the tool and the action.
    Parameters:
      `source` - String representing the "source" attribute.